import sys
from typing import Optional, Any, List

from PyQt6 import QtWidgets, QtCore
from PyQt6.QtCore import QAbstractListModel, QModelIndex, Qt, pyqtSlot
from PyQt6.QtWidgets import QMainWindow


class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(779, 474)
        self.centralwidget = QtWidgets.QWidget(parent=MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.listView = QtWidgets.QListView(parent=self.centralwidget)
        self.listView.setGeometry(QtCore.QRect(150, 50, 331, 321))
        self.listView.setObjectName("listView")
        MainWindow.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(parent=MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 779, 22))
        self.menubar.setObjectName("menubar")
        MainWindow.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(parent=MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MainWindow"))


class MyListModel(QAbstractListModel):
    def __init__(self):
        super().__init__(None)
        self.checked: bool = False

    def columnCount(self, parent: QModelIndex = None, *args, **kwargs) -> int:
        return 1

    def rowCount(self, parent: QModelIndex = None, *args, **kwargs) -> int:
        return 1

    def data(self, index: QModelIndex, role: int = None) -> Optional[Any]:
        if not index.isValid():
            return None
        if role == Qt.ItemDataRole.DisplayRole:
            return "Item#1"
        elif role == Qt.ItemDataRole.CheckStateRole:
            return Qt.CheckState.Checked if self.checked else Qt.CheckState.Unchecked
        return None

    def setData(self, index: QModelIndex, data: Any, role: int = Qt.ItemDataRole.EditRole) -> bool:
        if not index.isValid():
            return False
        if role == Qt.ItemDataRole.CheckStateRole:
            self.checked = True if data else False
            self.dataChanged.emit(index, index, [role])
            return True
        return False

    def flags(self, index: QModelIndex) -> Optional[Qt.ItemFlag]:
        if not index.isValid():
            return None
        return Qt.ItemFlag.ItemIsEnabled | Qt.ItemFlag.ItemIsSelectable | Qt.ItemFlag.ItemIsUserCheckable


class MainWindow(QMainWindow, Ui_MainWindow):
    def __init__(self):
        super().__init__()
        self.setupUi(self)
        self.model: MyListModel = MyListModel()
        self.model.dataChanged.connect(self.on_data_changed)
        self.listView.setModel(self.model)

    @pyqtSlot("QModelIndex", "QModelIndex", "QList<int>")
    def on_data_changed(self, top_left: QModelIndex, bottom_right: QModelIndex, roles: List[int]):
        print("triggered")


if __name__ == "__main__":
    app = QtWidgets.QApplication(sys.argv)
    main_window = MainWindow()
    main_window.show()
    app.exec()
